<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" 
        xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
        xmlns:xs="http://www.w3.org/2001/XMLSchema"
        xmlns:msdata="urn:schemas-microsoft-com:xml-msdata" >
    <xsl:strip-space elements="*"/>
    <xsl:output method="xml" indent="yes"/> 
    <xsl:include href="Support.xslt"/>
 
 <!-- Copyright Kathleen Dollard 2002 -->
 
<xsl:template match="/xs:schema/xs:element"> 
	<xsl:element name="DataSet">
		<xsl:attribute name="name">
			<xsl:call-template name="FixKeywords"><xsl:with-param name="Identifier"><xsl:value-of select="@name"/></xsl:with-param></xsl:call-template>
		</xsl:attribute>
		<xsl:attribute name="origname">
			<xsl:value-of select="@name"/>
		</xsl:attribute>
		<xsl:text>&#xa;&#x9;</xsl:text>
		<xsl:apply-templates select="xs:complexType/xs:choice/xs:element" />
		<xsl:text>&#xa;&#x9;</xsl:text>
		<xsl:apply-templates select="xs:unique" />
		<xsl:apply-templates select="xs:keyref" />
		<xsl:text>&#xa;&#x9;</xsl:text>
	</xsl:element>
</xsl:template>
 
<xsl:template match="xs:complexType/xs:choice/xs:element"> 
	<xsl:text>&#x9;</xsl:text>
	<xsl:element name="DataTable">
		<xsl:attribute name="name">
			<xsl:call-template name="FixKeywords"><xsl:with-param name="Identifier"><xsl:value-of select="@name"/></xsl:with-param></xsl:call-template>
		</xsl:attribute>
		<xsl:attribute name="origname">
			<xsl:value-of select="@name"/>
		</xsl:attribute>
		<xsl:text>&#xa;&#x9;&#x9;</xsl:text>
      <xsl:apply-templates select="xs:complexType/xs:sequence/xs:element" />
	</xsl:element>
	<xsl:text>&#xa;&#x9;</xsl:text>
</xsl:template>

<xsl:template match="xs:complexType/xs:sequence/xs:element" > 
	<xsl:text>&#x9;</xsl:text>
	<xsl:element name="DataColumn">
		<xsl:attribute name="name">
			<xsl:call-template name="FixKeywords"><xsl:with-param name="Identifier"><xsl:value-of select="@name"/></xsl:with-param></xsl:call-template>
		</xsl:attribute>
		<xsl:attribute name="origname">
			<xsl:value-of select="@name"/>
		</xsl:attribute>
		<xsl:variable name="NETType"><xsl:call-template name="NETType"/></xsl:variable>
		<xsl:attribute name="type">
			<xsl:value-of select="$NETType"/>
		</xsl:attribute>
		<xsl:attribute name="VBType">
			<xsl:call-template name="NETToVBType"><xsl:with-param name="Type" select="$NETType"/></xsl:call-template>
		</xsl:attribute>
		<xsl:if test="not(@minOccurs='0')">
			<xsl:attribute name="AllowDBNulls">false</xsl:attribute>
		</xsl:if>
		<xsl:for-each select="@msdata:ReadOnly">
			<xsl:attribute name="ReadOnly">true</xsl:attribute>
		</xsl:for-each>
		<xsl:for-each select="@msdata:AutoIncrement">
			<xsl:attribute name="AutoIncrement">true</xsl:attribute>
		</xsl:for-each>
	</xsl:element>
	<xsl:text>&#xa;&#x9;&#x9;</xsl:text>
</xsl:template>

<xsl:template match="xs:keyref" > 
        <!-- The code in this template is rather convoluted and I suggest you just use it. -->
        <xsl:variable name="RefName" select="@refer" />
        <xsl:variable name="ChildTable" select="substring-after(xs:selector/@xpath,':')" />
        <xsl:variable name="ChildKeys" select="xs:field" />
        <xsl:variable name="ConstraintName" select="@name" />
        <xsl:for-each select="parent::*" >
        <xsl:for-each select="xs:unique[@name=$RefName]" >
        <xsl:variable name="ParentTable" select="substring-after(xs:selector/@xpath,':')" />
        <xsl:variable name="ParentKeys" select="xs:field" />
		  <xsl:text>&#xa;&#x9;&#x9;</xsl:text>
		  <xsl:element name="Relation">
				<xsl:attribute name="name">
					<xsl:call-template name="FixKeywords"><xsl:with-param name="Identifier"><xsl:value-of select="$ConstraintName"/></xsl:with-param></xsl:call-template>
				</xsl:attribute>
				<xsl:attribute name="refer">
					<xsl:value-of select="$RefName"/>
				</xsl:attribute>
	 		   <xsl:text>&#xa;&#x9;&#x9;&#x9;</xsl:text>
				<xsl:element name="ParentTable">
					<xsl:call-template name="FixKeywords"><xsl:with-param name="Identifier"><xsl:value-of select="$ParentTable"/></xsl:with-param></xsl:call-template>
				</xsl:element>
			   <xsl:text>&#xa;&#x9;&#x9;&#x9;</xsl:text>
				<xsl:element name="ParentKeys">
					<xsl:for-each select="$ParentKeys" >
						<xsl:call-template name="FixKeywords"><xsl:with-param name="Identifier"><xsl:value-of select="substring-after(@xpath,':')"/></xsl:with-param></xsl:call-template>
					</xsl:for-each>
				</xsl:element>
				<xsl:text>&#xa;&#x9;&#x9;&#x9;</xsl:text>
				<xsl:element name="ChildTable">
					<xsl:call-template name="FixKeywords"><xsl:with-param name="Identifier"><xsl:value-of select="$ChildTable"/></xsl:with-param></xsl:call-template>
				</xsl:element>
				<xsl:text>&#xa;&#x9;&#x9;&#x9;</xsl:text>
				<xsl:element name="ChildKeys">
					<xsl:for-each select="$ChildKeys" >
						<xsl:call-template name="FixKeywords"><xsl:with-param name="Identifier"><xsl:value-of select="substring-after(@xpath,':')"/></xsl:with-param></xsl:call-template>
					</xsl:for-each>
				</xsl:element>
				<xsl:text>&#xa;&#x9;&#x9;</xsl:text>
		  </xsl:element>
        </xsl:for-each>
        </xsl:for-each>
</xsl:template>

<xsl:template match="xs:unique" > 
	<xsl:text>&#x9;</xsl:text>
	<xsl:element name="PrimaryKey">
		<xsl:attribute name="name">
			<xsl:call-template name="FixKeywords"><xsl:with-param name="Identifier"><xsl:value-of select="@name"/></xsl:with-param></xsl:call-template>
		</xsl:attribute>
		<xsl:attribute name="table">
			<xsl:for-each select="xs:selector">
				<xsl:call-template name="FixKeywords"><xsl:with-param name="Identifier"><xsl:value-of select="substring-after(@xpath,':')"/></xsl:with-param></xsl:call-template>
			</xsl:for-each>
		</xsl:attribute>
		<xsl:for-each select="xs:field">
			<xsl:text>&#xa;&#x9;&#x9;&#x9;</xsl:text>
			<xsl:element name="field">
				<xsl:call-template name="FixKeywords"><xsl:with-param name="Identifier"><xsl:value-of select="substring-after(@xpath,':')"/></xsl:with-param></xsl:call-template>
			</xsl:element>
		</xsl:for-each>
		<xsl:text>&#xa;&#x9;&#x9;</xsl:text>
	</xsl:element>
	<xsl:text>&#xa;&#x9;</xsl:text>
</xsl:template>


</xsl:stylesheet>


  