package fr.imag.adele.ant.remoreant.task;

import java.io.File;
import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Map;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import fr.imag.adele.ant.remoreant.RemoteAntService;

/**
 * @author didier donsez
 */
public class RemoteAntTask extends Task {

	/** Holds value of property buildFile. */
	private Map properties;

	/** Holds value of property buildFile. */
	private File buildFile;

	/** Holds value of property target. */
	private String target;

	/** Holds value of property soapURL. */
	private String url;

	public void execute() throws BuildException {
		try {
			RemoteAntService ra;
			ra = (RemoteAntService) Naming.lookup(url);
			String buildDocument = null; // load the file

			byte[] result = ra.execute(buildDocument, target, properties);
			getProject().log(result.toString());
		} catch (RemoteException e) {
			throw new BuildException(e);
		} catch (MalformedURLException e) {
			throw new BuildException(e);
		} catch (NotBoundException e) {
			throw new BuildException(e);
		}
	}

	/** Setter for property buildFile.
	 * @param buildFile New value of property buildFile.
	 */
	public void setBuildFile(File buildFile) {
		this.buildFile = buildFile;
	}

	/** Setter for property target.
	 * @param target New value of property target.
	 */
	public void setTarget(String target) {
		this.target = target;
	}

	/** Setter for property url.
	 * @param url New value of property url.
	 */
	public void setUrl(String url) {
		this.url = url;
	}

	public void addProperty(Property property) {
		if (properties == null)
			properties = new HashMap();
		properties.put(property.getName(), property.getValue());
	}

	public class Property {
		private String name;
		private String value;

		/**
		 * @return
		 */
		public String getName() {
			return name;
		}

		/**
		 * @return
		 */
		public String getValue() {
			return value;
		}

		/**
		 * @param string
		 */
		public void setName(String string) {
			name = string;
		}

		/**
		 * @param string
		 */
		public void setValue(String string) {
			value = string;
		}
	}
}
